Index: /palm/trunk/UTIL/inifor/src/inifor_grid.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3865)
+++ /palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3866)
@@ -3670,20 +3689,20 @@
 !> array will match a COSMO-DE scalar array.
 !------------------------------------------------------------------------------!
-    SUBROUTINE preprocess(group, input_buffer, cosmo_grid, iter)
-
-       TYPE(io_group), INTENT(INOUT), TARGET       ::  group
-       TYPE(container), INTENT(INOUT), ALLOCATABLE ::  input_buffer(:)
-       TYPE(grid_definition), INTENT(IN)           ::  cosmo_grid
-       INTEGER, INTENT(IN)                         ::  iter
-       
-       REAL(dp), ALLOCATABLE                       ::  basic_state_pressure(:)
-       TYPE(container), ALLOCATABLE                ::  preprocess_buffer(:)
-       INTEGER                                     ::  hour, dt
-       INTEGER                                     ::  i, j, k
-       INTEGER                                     ::  nx, ny, nz
-       
-       input_buffer(:) % is_preprocessed = .FALSE.
-        
-       SELECT CASE( group % kind )
+ SUBROUTINE preprocess(group, input_buffer, cosmo_grid, iter)
+
+    TYPE(io_group), INTENT(INOUT), TARGET       ::  group
+    TYPE(container), INTENT(INOUT), ALLOCATABLE ::  input_buffer(:)
+    TYPE(grid_definition), INTENT(IN)           ::  cosmo_grid
+    INTEGER, INTENT(IN)                         ::  iter
+    
+    REAL(wp), ALLOCATABLE                       ::  basic_state_pressure(:)
+    TYPE(container), ALLOCATABLE                ::  preprocess_buffer(:)
+    INTEGER                                     ::  hour, dt
+    INTEGER                                     ::  i, j, k
+    INTEGER                                     ::  nx, ny, nz
+    
+    input_buffer(:)%is_preprocessed = .FALSE.
+     
+    SELECT CASE( group%kind )
        
        CASE( 'velocities' )
@@ -3694,71 +3713,71 @@
 !
 !--       Allocate u and v arrays with scalar dimensions
-          nx = SIZE(input_buffer(1) % array, 1)
-          ny = SIZE(input_buffer(1) % array, 2)
-          nz = SIZE(input_buffer(1) % array, 3)
-          ALLOCATE( preprocess_buffer(1) % array(nx, ny, nz) ) ! u buffer
-          ALLOCATE( preprocess_buffer(2) % array(nx, ny, nz) ) ! v buffer
-
- CALL run_control('time', 'alloc')
+          nx = SIZE(input_buffer(1)%array, 1)
+          ny = SIZE(input_buffer(1)%array, 2)
+          nz = SIZE(input_buffer(1)%array, 3)
+          ALLOCATE( preprocess_buffer(1)%array(nx, ny, nz) ) ! u buffer
+          ALLOCATE( preprocess_buffer(2)%array(nx, ny, nz) ) ! v buffer
+
+          CALL log_runtime('time', 'alloc')
 
 !
 !--       interpolate U and V to centres
-          CALL centre_velocities( u_face = input_buffer(1) % array,            &
-                                  v_face = input_buffer(2) % array,            &
-                                  u_centre = preprocess_buffer(1) % array,     &
-                                  v_centre = preprocess_buffer(2) % array )
+          CALL centre_velocities( u_face = input_buffer(1)%array,            &
+                                  v_face = input_buffer(2)%array,            &
+                                  u_centre = preprocess_buffer(1)%array,     &
+                                  v_centre = preprocess_buffer(2)%array )
           
-          cfg % rotation_method = 'rotated-pole'
-          SELECT CASE(cfg % rotation_method)
-
-          CASE('rotated-pole')
-!
-!--          rotate U and V to PALM-4U orientation and overwrite U and V with
-!--          rotated velocities
-             DO k = 1, nz
-             DO j = 1, ny
-             DO i = 1, nx
-                CALL uv2uvrot( urot = preprocess_buffer(1) % array(i,j,k),     &
-                               vrot = preprocess_buffer(2) % array(i,j,k),     &
-                               rlat = cosmo_grid % lat(j-1),                   &
-                               rlon = cosmo_grid % lon(i-1),                   &
-                               pollat = phi_cn,                                &
-                               pollon = lambda_cn,                             &
-                               u = input_buffer(1) % array(i,j,k),             &
-                               v = input_buffer(2) % array(i,j,k) )
-             ENDDO
-             ENDDO
-             ENDDO
-
-          CASE DEFAULT
-             message = "Rotation method '" // TRIM(cfg % rotation_method) //   &
-                "' not recognized."
-             CALL inifor_abort('preprocess', message)
+          cfg%rotation_method = 'rotated-pole'
+          SELECT CASE(cfg%rotation_method)
+
+             CASE('rotated-pole')
+!            
+!--             rotate U and V to PALM-4U orientation and overwrite U and V with
+!--             rotated velocities
+                DO  k = 1, nz
+                DO  j = 1, ny
+                DO  i = 1, nx
+                   CALL uv2uvrot( urot = preprocess_buffer(1)%array(i,j,k),     &
+                                  vrot = preprocess_buffer(2)%array(i,j,k),     &
+                                  rlat = cosmo_grid%lat(j-1),                   &
+                                  rlon = cosmo_grid%lon(i-1),                   &
+                                  pollat = phi_cn,                                &
+                                  pollon = lambda_cn,                             &
+                                  u = input_buffer(1)%array(i,j,k),             &
+                                  v = input_buffer(2)%array(i,j,k) )
+                ENDDO
+                ENDDO
+                ENDDO
+             
+             CASE DEFAULT
+                message = "Rotation method '" // TRIM(cfg%rotation_method) //   &
+                   "' not recognized."
+                CALL inifor_abort('preprocess', message)
 
           END SELECT
 
-          input_buffer(1) % array(1,:,:) = 0.0_dp
-          input_buffer(2) % array(1,:,:) = 0.0_dp
-          input_buffer(1) % array(:,1,:) = 0.0_dp
-          input_buffer(2) % array(:,1,:) = 0.0_dp
-
-          input_buffer(1:2) % is_preprocessed = .TRUE.
- CALL run_control('time', 'comp')
+          input_buffer(1)%array(1,:,:) = 0.0_wp
+          input_buffer(2)%array(1,:,:) = 0.0_wp
+          input_buffer(1)%array(:,1,:) = 0.0_wp
+          input_buffer(2)%array(:,1,:) = 0.0_wp
+
+          input_buffer(1:2)%is_preprocessed = .TRUE.
+          CALL log_runtime('time', 'comp')
 
           DEALLOCATE( preprocess_buffer )
- CALL run_control('time', 'alloc')
-
-          message = "Input buffers for group '" // TRIM(group % kind) // "'"//&
+          CALL log_runtime('time', 'alloc')
+
+          message = "Input buffers for group '" // TRIM(group%kind) // "'"//&
              " preprocessed sucessfully."
           CALL report('preprocess', message)
        
        CASE( 'thermodynamics' ) ! T, P, QV
-          nx = SIZE(input_buffer(1) % array, 1)
-          ny = SIZE(input_buffer(1) % array, 2)
-          nz = SIZE(input_buffer(1) % array, 3)
+          nx = SIZE(input_buffer(1)%array, 1)
+          ny = SIZE(input_buffer(1)%array, 2)
+          nz = SIZE(input_buffer(1)%array, 3)
 
 !
 !--       Compute absolute pressure if presure perturbation has been read in.
-          IF ( TRIM(group % in_var_list(2) % name) == 'PP' )  THEN
+          IF ( TRIM(group%in_var_list(2)%name) == 'PP' )  THEN
              message = "Absolute pressure, P, not available, " //              &
                        "computing from pressure preturbation PP."
@@ -3766,10 +3785,10 @@
 
              ALLOCATE( basic_state_pressure(1:nz) )
- CALL run_control('time', 'alloc')
-
-             DO j = 1, ny
-             DO i = 1, nx
-
-                CALL get_basic_state(cosmo_grid % hfl(i,j,:), BETA, P_SL, T_SL,&
+             CALL log_runtime('time', 'alloc')
+
+             DO  j = 1, ny
+             DO  i = 1, nx
+
+                CALL get_basic_state(cosmo_grid%hfl(i,j,:), BETA, P_SL, T_SL,&
                                      RD, G, basic_state_pressure)
 
@@ -3777,35 +3796,36 @@
 !--             Overwrite pressure perturbation with absolute pressure. HECTO
 !--             converts pressure perturbation from hPa to Pa.
-                input_buffer (2) % array(i,j,:) =                              &
-                   HECTO * input_buffer (2) % array(i,j,:) +                   &
+                input_buffer (2)%array(i,j,:) =                              &
+                   HECTO * input_buffer (2)%array(i,j,:) +                   &
                    basic_state_pressure(:)
 
              ENDDO
              ENDDO
- CALL run_control('time', 'comp')
+             CALL log_runtime('time', 'comp')
 
              DEALLOCATE( basic_state_pressure )
- CALL run_control('time', 'alloc')
-
-             group % in_var_list(2) % name = 'P'
+             CALL log_runtime('time', 'alloc')
+
+             group%in_var_list(2)%name = 'P'
 
           ENDIF
 !
 !--       mark pressure as preprocessed
-          input_buffer(2) % is_preprocessed = .TRUE.
+          input_buffer(2)%is_preprocessed = .TRUE.
 
 !
 !--       Copy temperature to the last input buffer array
           ALLOCATE(                                                            &
-              input_buffer( group % n_output_quantities ) % array (nx, ny, nz) &
+              input_buffer( group%n_output_quantities )%array (nx, ny, nz) &
           )
-          input_buffer(group % n_output_quantities) % array(:,:,:) =           &
-              input_buffer(1) % array(:,:,:)
+          CALL log_runtime('time', 'alloc')
+          input_buffer(group%n_output_quantities)%array(:,:,:) =           &
+              input_buffer(1)%array(:,:,:)
 
 !
 !--       Convert absolute in place to potential temperature
           CALL potential_temperature(                                          &
-             t = input_buffer(1) % array(:,:,:),                               &
-             p = input_buffer(2) % array(:,:,:),                               &
+             t = input_buffer(1)%array(:,:,:),                               &
+             p = input_buffer(2)%array(:,:,:),                               &
              p_ref = P_REF,                                                    &
              r = RD_PALM,                                                      &
@@ -3815,12 +3835,12 @@
 !
 !--       mark potential temperature as preprocessed
-          input_buffer(1) % is_preprocessed = .TRUE.
+          input_buffer(1)%is_preprocessed = .TRUE.
 
 !
 !--       Convert temperature copy to density
           CALL moist_density(                                                  &
-             t_rho = input_buffer(group % n_output_quantities) % array(:,:,:), &
-             p = input_buffer(2) % array(:,:,:),                               &
-             qv = input_buffer(3) % array(:,:,:),                              &
+             t_rho = input_buffer(group%n_output_quantities)%array(:,:,:), &
+             p = input_buffer(2)%array(:,:,:),                               &
+             qv = input_buffer(3)%array(:,:,:),                              &
              rd = RD,                                                          &
              rv = RV                                                           &
@@ -3829,43 +3849,40 @@
 !
 !--       mark qv as preprocessed
-          input_buffer(3) % is_preprocessed = .TRUE.
+          input_buffer(3)%is_preprocessed = .TRUE.
 
 !
 !--       mark density as preprocessed
-          input_buffer(group % n_output_quantities) % is_preprocessed = .TRUE.
-
-
-          message = "Input buffers for group '" // TRIM(group % kind) // "'"//&
+          input_buffer(group%n_output_quantities)%is_preprocessed = .TRUE.
+
+
+          message = "Input buffers for group '" // TRIM(group%kind) // "'"//&
              " preprocessed sucessfully."
           CALL report('preprocess', message)
- CALL run_control('time', 'comp')
        
        CASE( 'scalar' ) ! S or W
-          input_buffer(:) % is_preprocessed = .TRUE.
- CALL run_control('time', 'comp')
+          input_buffer(:)%is_preprocessed = .TRUE.
 
        CASE( 'soil-temperature' ) ! 
           
-          CALL fill_water_cells(soiltyp, input_buffer(1) % array, &
-                                SIZE(input_buffer(1) % array, 3), &
+          CALL fill_water_cells(soiltyp, input_buffer(1)%array, &
+                                SIZE(input_buffer(1)%array, 3), &
                                 FILL_ITERATIONS)
-          input_buffer(:) % is_preprocessed = .TRUE.
- CALL run_control('time', 'comp')
+          input_buffer(:)%is_preprocessed = .TRUE.
 
        CASE( 'soil-water' ) ! 
 
-          CALL fill_water_cells(soiltyp, input_buffer(1) % array, &
-                                SIZE(input_buffer(1) % array, 3), &
+          CALL fill_water_cells(soiltyp, input_buffer(1)%array, &
+                                SIZE(input_buffer(1)%array, 3), &
                                 FILL_ITERATIONS)
 
-          nx = SIZE(input_buffer(1) % array, 1)
-          ny = SIZE(input_buffer(1) % array, 2)
-          nz = SIZE(input_buffer(1) % array, 3)
-
-          DO k = 1, nz
-          DO j = 1, ny
-          DO i = 1, nx
-             input_buffer(1) % array(i,j,k) =                                  &
-                 input_buffer(1) % array(i,j,k) * d_depth_rho_inv(k)
+          nx = SIZE(input_buffer(1)%array, 1)
+          ny = SIZE(input_buffer(1)%array, 2)
+          nz = SIZE(input_buffer(1)%array, 3)
+
+          DO  k = 1, nz
+          DO  j = 1, ny
+          DO  i = 1, nx
+             input_buffer(1)%array(i,j,k) =                                  &
+                 input_buffer(1)%array(i,j,k) * d_depth_rho_inv(k)
           ENDDO
           ENDDO
@@ -3875,13 +3892,11 @@
           CALL report('preprocess', message)
 
-          input_buffer(:) % is_preprocessed = .TRUE.
- CALL run_control('time', 'comp')
+          input_buffer(:)%is_preprocessed = .TRUE.
 
        CASE( 'surface' ) ! 
-          input_buffer(:) % is_preprocessed = .TRUE.
- CALL run_control('time', 'comp')
+          input_buffer(:)%is_preprocessed = .TRUE.
 
        CASE( 'accumulated' ) ! 
-          message = "De-accumulating '" // TRIM(group % in_var_list(1) % name) //&
+          message = "De-accumulating '" // TRIM(group%in_var_list(1)%name) //&
                     "' in iteration " // TRIM(str(iter)) 
           CALL report('preprocess', message)
@@ -3892,42 +3907,41 @@
 
 !
-!--       input has been accumulated over one hour. Leave as is
-!--       input_buffer(1) % array(:,:,:) carrries one-hour integral
-          CASE(1)
-
-!
-!--       input has been accumulated over two hours. Subtract previous step
-!--       input_buffer(1) % array(:,:,:) carrries one-hour integral
-!--       input_buffer(2) % array(:,:,:) carrries two-hour integral
-          CASE(2)
-             CALL deaverage(                                                   &
-                      avg_1 = input_buffer(1) % array(:,:,:), t1 = 1.0_dp,     &
-                      avg_2 = input_buffer(2) % array(:,:,:), t2 = 1.0_dp,     &
-                      avg_3 = input_buffer(1) % array(:,:,:), t3 = 1.0_dp )
-!
-!--          input_buffer(1) % array(:,:,:) carrries one-hour integral of second hour
-
-!
-!--       input has been accumulated over three hours. Subtract previous step
-!--       input_buffer(1) % array(:,:,:) carrries three-hour integral
-!--       input_buffer(2) % array(:,:,:) still carrries two-hour integral
-          CASE(3)
-             CALL deaverage(                                                   &
-                     avg_1 = input_buffer(2) % array(:,:,:), t1 = 1.0_dp,      &
-                     avg_2 = input_buffer(1) % array(:,:,:), t2 = 1.0_dp,      &
-                     avg_3 = input_buffer(1) % array(:,:,:), t3 = 1.0_dp )
-!
-!--          input_buffer(1) % array(:,:,:) carrries one-hour integral of third hourA
-
-          CASE DEFAULT
-             message = "Invalid averaging period '" // TRIM(str(dt)) // " hours"
-             CALL inifor_abort('preprocess', message)
+!--          input has been accumulated over one hour. Leave as is
+!--          input_buffer(1)%array(:,:,:) carrries one-hour integral
+             CASE(1)
+             
+!            
+!--          input has been accumulated over two hours. Subtract previous step
+!--          input_buffer(1)%array(:,:,:) carrries one-hour integral
+!--          input_buffer(2)%array(:,:,:) carrries two-hour integral
+             CASE(2)
+                CALL deaverage(                                                   &
+                         avg_1 = input_buffer(1)%array(:,:,:), t1 = 1.0_wp,     &
+                         avg_2 = input_buffer(2)%array(:,:,:), t2 = 1.0_wp,     &
+                         avg_3 = input_buffer(1)%array(:,:,:), t3 = 1.0_wp )
+!            
+!--             input_buffer(1)%array(:,:,:) carrries one-hour integral of second hour
+             
+!            
+!--          input has been accumulated over three hours. Subtract previous step
+!--          input_buffer(1)%array(:,:,:) carrries three-hour integral
+!--          input_buffer(2)%array(:,:,:) still carrries two-hour integral
+             CASE(3)
+                CALL deaverage(                                                   &
+                        avg_1 = input_buffer(2)%array(:,:,:), t1 = 1.0_wp,      &
+                        avg_2 = input_buffer(1)%array(:,:,:), t2 = 1.0_wp,      &
+                        avg_3 = input_buffer(1)%array(:,:,:), t3 = 1.0_wp )
+!            
+!--             input_buffer(1)%array(:,:,:) carrries one-hour integral of third hourA
+             
+             CASE DEFAULT
+                message = "Invalid averaging period '" // TRIM(str(dt)) // " hours"
+                CALL inifor_abort('preprocess', message)
 
           END SELECT
-          input_buffer(:) % is_preprocessed = .TRUE.
- CALL run_control('time', 'comp')
+          input_buffer(:)%is_preprocessed = .TRUE.
 
        CASE( 'running average' ) ! 
-          message = "De-averaging '" // TRIM(group % in_var_list(1) % name) //   &
+          message = "De-averaging '" // TRIM(group%in_var_list(1)%name) //   &
                     "' in iteration " // TRIM(str(iter)) 
           CALL report('preprocess', message)
@@ -3939,45 +3953,45 @@
           SELECT CASE(dt)
 !
-!--       input has been accumulated over one hour. Leave as is
-!--       input_buffer(1) % array(:,:,:) carrries one-hour integral
-          CASE(1)
-
-!
-!--       input has been accumulated over two hours. Subtract previous step
-!--       input_buffer(1) % array(:,:,:) carrries one-hour integral
-!--       input_buffer(2) % array(:,:,:) carrries two-hour integral
-          CASE(2)
-             CALL deaverage( input_buffer(1) % array(:,:,:), 1.0_dp,           &
-                             input_buffer(2) % array(:,:,:), 2.0_dp,           &
-                             input_buffer(1) % array(:,:,:), 1.0_dp)
-!
-!--          input_buffer(1) % array(:,:,:) carrries one-hour integral of second hour
-
-!
-!--       input has been accumulated over three hours. Subtract previous step
-!--       input_buffer(1) % array(:,:,:) carrries three-hour integral
-!--       input_buffer(2) % array(:,:,:) still carrries two-hour integral
-          CASE(3)
-             CALL deaverage( input_buffer(2) % array(:,:,:), 2.0_dp,           &
-                             input_buffer(1) % array(:,:,:), 3.0_dp,           &
-                             input_buffer(1) % array(:,:,:), 1.0_dp)
-!
-!--          input_buffer(1) % array(:,:,:) carrries one-hour integral of third hourA
-
-          CASE DEFAULT
-             message = "Invalid averaging period '" // TRIM(str(dt)) // " hours"
-             CALL inifor_abort('preprocess', message)
+!--          input has been accumulated over one hour. Leave as is
+!--          input_buffer(1)%array(:,:,:) carrries one-hour integral
+             CASE(1)
+             
+!            
+!--          input has been accumulated over two hours. Subtract previous step
+!--          input_buffer(1)%array(:,:,:) carrries one-hour integral
+!--          input_buffer(2)%array(:,:,:) carrries two-hour integral
+             CASE(2)
+                CALL deaverage( input_buffer(1)%array(:,:,:), 1.0_wp,           &
+                                input_buffer(2)%array(:,:,:), 2.0_wp,           &
+                                input_buffer(1)%array(:,:,:), 1.0_wp)
+!            
+!--             input_buffer(1)%array(:,:,:) carrries one-hour integral of second hour
+             
+!            
+!--          input has been accumulated over three hours. Subtract previous step
+!--          input_buffer(1)%array(:,:,:) carrries three-hour integral
+!--          input_buffer(2)%array(:,:,:) still carrries two-hour integral
+             CASE(3)
+                CALL deaverage( input_buffer(2)%array(:,:,:), 2.0_wp,           &
+                                input_buffer(1)%array(:,:,:), 3.0_wp,           &
+                                input_buffer(1)%array(:,:,:), 1.0_wp)
+!            
+!--             input_buffer(1)%array(:,:,:) carrries one-hour integral of third hourA
+             
+             CASE DEFAULT
+                message = "Invalid averaging period '" // TRIM(str(dt)) // " hours"
+                CALL inifor_abort('preprocess', message)
 
           END SELECT
-          input_buffer(:) % is_preprocessed = .TRUE.
+          input_buffer(:)%is_preprocessed = .TRUE.
 
        CASE DEFAULT
-          message = "IO group kind '" // TRIM(group % kind) // "' is not supported."
+          message = "IO group kind '" // TRIM(group%kind) // "' is not supported."
           CALL inifor_abort('prerpocess', message)
 
-       END SELECT
- CALL run_control('time', 'comp')
-
-    END SUBROUTINE preprocess
+    END SELECT
+    CALL log_runtime('time', 'comp')
+
+ END SUBROUTINE preprocess
 
 
@@ -4006,68 +4020,68 @@
 !> array : the soil array (i.e. water content or temperature)
 !------------------------------------------------------------------------------!
-    SUBROUTINE fill_water_cells(soiltyp, array, nz, niter)
-       INTEGER(hp), DIMENSION(:,:,:), INTENT(IN) :: soiltyp
-       REAL(dp), DIMENSION(:,:,:), INTENT(INOUT) :: array
-       INTEGER, INTENT(IN)                       :: nz, niter
-
-       REAL(dp), DIMENSION(nz)                   :: column
-       INTEGER(hp), DIMENSION(:,:), ALLOCATABLE  :: old_soiltyp, new_soiltyp
-       INTEGER                                   :: l, i, j, nx, ny, n_cells, ii, jj, iter
-       INTEGER, DIMENSION(8)                     :: di, dj
-
-       nx = SIZE(array, 1)
-       ny = SIZE(array, 2)
-       di = (/ -1, -1, -1, 0,  0,  1, 1, 1 /)
-       dj = (/ -1,  0,  1, -1, 1, -1, 0, 1 /)
-
-       ALLOCATE(old_soiltyp(SIZE(soiltyp,1), &
-                            SIZE(soiltyp,2) ))
-
-       ALLOCATE(new_soiltyp(SIZE(soiltyp,1), &
-                            SIZE(soiltyp,2) ))
-
-       old_soiltyp(:,:) = soiltyp(:,:,1)
-       new_soiltyp(:,:) = soiltyp(:,:,1)
-
-       DO iter = 1, niter
-
-          DO j = 1, ny
-          DO i = 1, nx
-          
-             IF (old_soiltyp(i,j) == WATER_ID)  THEN 
-
-                n_cells = 0
-                column(:) = 0.0_dp
-                DO l = 1, SIZE(di)
-
-                   ii = MIN(nx, MAX(1, i + di(l)))
-                   jj = MIN(ny, MAX(1, j + dj(l)))
-
-                   IF (old_soiltyp(ii,jj) .NE. WATER_ID)  THEN
-                      n_cells = n_cells + 1
-                      column(:) = column(:) + array(ii,jj,:)
-                   ENDIF
-
-                ENDDO
-
-!
-!--             Overwrite if at least one non-water neighbour cell is available
-                IF (n_cells > 0)  THEN
-                   array(i,j,:) = column(:) / n_cells
-                   new_soiltyp(i,j) = 0
+ SUBROUTINE fill_water_cells(soiltyp, array, nz, niter)
+    INTEGER(iwp), DIMENSION(:,:,:), INTENT(IN) :: soiltyp
+    REAL(wp), DIMENSION(:,:,:), INTENT(INOUT)  :: array
+    INTEGER, INTENT(IN)                        :: nz, niter
+
+    REAL(wp), DIMENSION(nz)                    :: column
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE  :: old_soiltyp, new_soiltyp
+    INTEGER                                    :: l, i, j, nx, ny, n_cells, ii, jj, iter
+    INTEGER, DIMENSION(8)                      :: di, dj
+
+    nx = SIZE(array, 1)
+    ny = SIZE(array, 2)
+    di = (/ -1, -1, -1, 0,  0,  1, 1, 1 /)
+    dj = (/ -1,  0,  1, -1, 1, -1, 0, 1 /)
+
+    ALLOCATE(old_soiltyp(SIZE(soiltyp,1), &
+                         SIZE(soiltyp,2) ))
+
+    ALLOCATE(new_soiltyp(SIZE(soiltyp,1), &
+                         SIZE(soiltyp,2) ))
+
+    old_soiltyp(:,:) = soiltyp(:,:,1)
+    new_soiltyp(:,:) = soiltyp(:,:,1)
+
+    DO  iter = 1, niter
+
+       DO  j = 1, ny
+       DO  i = 1, nx
+       
+          IF (old_soiltyp(i,j) == WATER_ID)  THEN 
+
+             n_cells = 0
+             column(:) = 0.0_wp
+             DO  l = 1, SIZE(di)
+
+                ii = MIN(nx, MAX(1, i + di(l)))
+                jj = MIN(ny, MAX(1, j + dj(l)))
+
+                IF (old_soiltyp(ii,jj) .NE. WATER_ID)  THEN
+                   n_cells = n_cells + 1
+                   column(:) = column(:) + array(ii,jj,:)
                 ENDIF
 
+             ENDDO
+
+!
+!--          Overwrite if at least one non-water neighbour cell is available
+             IF (n_cells > 0)  THEN
+                array(i,j,:) = column(:) / n_cells
+                new_soiltyp(i,j) = 0
              ENDIF
 
-          ENDDO
-          ENDDO
-
-          old_soiltyp(:,:) = new_soiltyp(:,:)
+          ENDIF
 
        ENDDO
-
-       DEALLOCATE(old_soiltyp, new_soiltyp)
-
-    END SUBROUTINE fill_water_cells
+       ENDDO
+
+       old_soiltyp(:,:) = new_soiltyp(:,:)
+
+    ENDDO
+
+    DEALLOCATE(old_soiltyp, new_soiltyp)
+
+ END SUBROUTINE fill_water_cells
 
 
